unit ldn180u1;

{$mode objfpc}{$H+}

//This has the ideas from http://sheepdogguides.com/lut/lt1Ne.htm
//  incorporated... little "tricks" like the setting of the
//  form's caption. (The ideas present 28 Oct 17, anyway.)

//This... LDN_180... is a DEVELOPMENT OF LDN181. I started
//  a derivative, this, as LDN_180... note 180 AFTER 181,
//  and bigger/better, despite lower index.
//This "re-start" to help with eventual tutorials.

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Clipbrd, ExtCtrls, Inifiles;

type

  { TLDN180f1 }

  TLDN180f1 = class(TForm)
    buQuit: TButton;
    buOnlineLink: TButton;
    buSomeShapes: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Image1: TImage;
    Memo1: TMemo;
    procedure buQuitClick(Sender: TObject);
    procedure buOnlineLinkClick(Sender: TObject);
    procedure buSomeShapesClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    iImageWidth, iImageHeight:integer;
    Bitmap:TBitmap;
    sTmp:string;
    clTmp,clBkG,clLine0,clLine1,clLine2,
      {clLoc0,clLoc1,clLoc2, for something
          I intend to develop of of this startthis.}
      clPnt0,clPnt1,clPnt2:TColor;//See Inifile for purposes of colors
    procedure ShapeDrawErase(bWhich,bSize:byte;ix,iy:integer;clColorL:TColor);
    procedure DrawTrialLine(bType:byte;clColorL:TColor);
    procedure DrawBarsOfColor;
    procedure DrawLineForShape(iX0L,iy0L,iX1L,iY1L:integer);
    procedure TestColors;
    procedure RandomlyPlacedShapes;
    procedure RandomlyPlacedShapes2(bSleepBetween,
          bHowManyTimesThroughLoop,bHowManyShowAtOnce:byte);

  public
    { public declarations }
  end;

var
  LDN180f1: TLDN180f1;

const vers='28 Oct 17b';
  //LDN_180 DERIVED FROM the simpler LDN_181.
  //LDN_180 was started 29 Oct 17 (Toe still a nuisance, but better!)

  //(LDN_181 started 28 Oct 17 as first step towards maps by
  //  triangulation, and tut on graphics. In midst of violent
  //  case of brain fizz... First serious SEO, first distributed
  //  data entry, in course of moving BooksRead to OOBase, etc, etc!
  //  And of first serious episode of gout like affliction, rt big
  //  toe, distal joint only.)

implementation

{$R *.lfm}//Resources
{$R+}//Range-checking

{ TLDN180f1 }

procedure TLDN180f1.FormCreate(Sender: TObject);
var dfIniFile:TIniFile;//See sheepdogguides.com/Lut/Lut2c.htm if you
  //want help with ini file stuff.
begin
  application.title:='LDN180';
  LDN180f1.caption:='LDN180- Demo of Lazarus Graphics. Vers '+ vers;

  //Ini file stuff...
  dfIniFile:=TIniFile.create('LDN180ini.txt');

  //Following doesn't fail if there's no LDN180ini.txt... that,
  //  in part, is what last parameter is for!
  //  (Said parameter also used if there IS a file, but no
  //     relevant entry in it.)
  with dfIniFile do begin
        iImageWidth:=ReadInteger('DrawingArea','Width',300);//Value
           //in this will be used in "Image1.width:=iImageWidth;"
        iImageHeight:=ReadInteger('DrawingArea','Height',200);//Diito, sort of!

        LDN180f1.width:=ReadInteger('WindowPosnAndSize','Width',580);
        LDN180f1.height:=ReadInteger('WindowPosnAndSize','Height',436);
        LDN180f1.left:=ReadInteger('WindowPosnAndSize','Left',20);
        LDN180f1.top:=ReadInteger('WindowPosnAndSize','Top',20);

        //Colors: Refer to the names used in the ini file
        //  for an idea of what the different colors are for.
        //There is the background color for the drawing area, the
        //  "graph"... the "paper", if you like.
        //Then there are three colors for representing points on
        //   the drawing, and three colors to use for lines.

        //REWORK THIS... KEEP STRINGS in ini file. Convert after collectiong.
        clTmp:=StringToColor('$FFFFFF');
          clBkg:=ReadInteger('Colors','BackGroundOfGraph',clTmp);
        clTmp:=StringToColor('$0C49FF');
          clPnt0:=ReadInteger('Colors','Point0',clTmp);
        clTmp:=StringToColor('$0076B2');
          clPnt1:=ReadInteger('Colors','Point1',clTmp);
        clTmp:=StringToColor('$00B283');
          clPnt2:=ReadInteger('Colors','Point2',clTmp);
        clTmp:=StringToColor('$FF0C34');
          clLine0:=ReadInteger('Colors','Line0',clTmp);
        clTmp:=StringToColor('$FF0CCE');
          clLine1:=ReadInteger('Colors','Line1',clTmp);
        sTmp:='$FF880C';
          clLine2:=ReadInteger('Colors','Line3',StringToColor(sTmp));
        end;//with
  dfIniFile.free;
  //(End Ini file stuff)

//Begin block mostly from
// http://sheepdogguides.com/lut/PixelProblem.htm

   Image1.width:=iImageWidth;
   Image1.height:=iImageHeight;

   Bitmap:=TBitmap.create;

   Bitmap.width:=iImageWidth;
   Bitmap.height:=iImageHeight;

   Bitmap.canvas.pen.color:=clWhite;
   Bitmap.canvas.Rectangle
       (0,0,iImagewidth,iImageHeight);

   Image1.Picture.Graphic:=Bitmap;
   //End block mostly from
   //   http://sheepdogguides.com/lut/PixelProblem.htm

end;//FormCreate

procedure TLDN180f1.FormActivate(Sender: TObject);
begin
  buOnlineLink.setfocus;
end;//FormActivate

procedure TLDN180f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure TLDN180f1.buOnlineLinkClick(Sender: TObject);
begin
    //Add ", Clipbrd" to Uses clause to allow the following...
    //My thanks to http://wiki.lazarus.freepascal.org/Clipboard
    //        for showing me how to do this)
    Clipboard.Clear;
    Clipboard.AsText:='http://sheepdogguides.com/lut/';
    Showmessage('A URL has been copied to your clipboard. Do a paste in '+
    'a browser navigation edit box to go to related material online.');
end;

procedure TLDN180f1.buSomeShapesClick(Sender: TObject);
var iCount:integer;
begin
    Image1.Picture.Bitmap.canvas.pen.mode:=pmXor;
    Image1.Picture.Bitmap.canvas.pen.color:=clPnt0 XOR clBkg;
    for iCount:=0 to 10 do
      ShapeDrawErase(0,4,(iCount*10)+10,(iCount*6)+10,0);
end;

procedure TLDN180f1.Button1Click(Sender: TObject);
begin
DrawTrialLine(0,clBlue);
end;

procedure TLDN180f1.Button2Click(Sender: TObject);
begin
DrawTrialLine(1,clLime);
end;

procedure TLDN180f1.Button3Click(Sender: TObject);
begin
  TestColors;
end;

procedure TLDN180f1.Button4Click(Sender: TObject);
begin
  DrawBarsOfColor;
end;

procedure TLDN180f1.Button5Click(Sender: TObject);
begin
  RandomlyPlacedShapes;
end;

procedure TLDN180f1.Button6Click(Sender: TObject);
begin
  Button4.enabled:=false;
  Button8.enabled:=false;//this is the "clear drawing area"
     //button. It (and some others) must not be clicked during
     //  the "rolling" draw/ (re-)draw... which erases... cycle
     //  of RandomlyPlacedShapes, or RandomlyPlacedShapes2, or
     //  puzzling-to-the-user artifacts arise.
     //There are other problematic buttons, but this is one
     //  example
     //
     //Anything XOR'd onto the screen is FINE... it is just if
     //  something is written otherwise that problems arise.
  RandomlyPlacedShapes2(10,255,15);
  Button4.enabled:=true;
  Button8.enabled:=true;
end;

procedure TLDN180f1.Button7Click(Sender: TObject);
begin
  Button4.enabled:=false;
  Button8.enabled:=false;//See Button7Click handler
  RandomlyPlacedShapes2(90,25,3);
  Button4.enabled:=true;
  Button8.enabled:=true;
end;

procedure TLDN180f1.Button8Click(Sender: TObject);
begin
  with Image1.Picture.Bitmap.canvas do begin
    brush.color:=clWhite;
    FillRect(Rect(0,0,iImageWidth,iImageHeight));
    end;//with
end;

procedure TLDN180f1.RandomlyPlacedShapes2(bSleepBetween,
  bHowManyTimesThroughLoop,bHowManyShowAtOnce:byte);
//bHowManyShowAtOnce must be less than bLastIndex. (bLastIndex-1?)
const kLastIndex = 16;
  //If set to 3, there will be FOUR on screen at once. A "count from
  //   zero" thing.

var iX,iY:array[0..kLastIndex] of integer;
    clN:array[0..kLastIndex] of TColor;
    bNextIndexToDraw,bCount,bToErase:byte;

  procedure PickNewNumbers(bWhich:byte);
  begin
     iX[bWhich]:=Random(iImageWidth);
     iY[bWhich]:=Random(iImageHeight);
     clN[bWhich]:=Random($FFFFFF) XOR clBkg;
  end;//PickNewNumbers- SR of RandomlyPlacedShapes2

begin //RandomlyPlacedShapes2
  if bHowManyShowAtOnce>=kLastIndex then
     showmessage('bHowManyShowAtOnce must not be >= kLastIndex');

  randomize;
  for bCount:=0 to kLastIndex do PickNewNumbers(bCount);

  Image1.Picture.Bitmap.canvas.pen.mode:=pmXor;

  bNextIndexToDraw:=0;
  if bHowManyShowAtOnce>kLastIndex
      then showmessage('Prmg flaw: 17a30: Can''t work with that conditon');
  //Put the first batch on image...
  for bCount:=0 to bHowManyShowAtOnce do begin
      ShapeDrawErase(0,4,iX[bCount],iY[bCount],clN[bCount]);
      //Shouldn't arise- if bNextIndexToDraw>bHowManyShowAtOnce then bNextIndexToDraw:=0;
      application.processmessages;//(Or else you don't see the draws
        //until loop finishes!)
      Sleep(bSleepBetween);
      end;//for
  bNextIndexToDraw:=bHowManyShowAtOnce+1;//Prepare for next.

  //Continue putting on... AND start taking off... (heart of it all)
  bToErase:=0;
  for bCount:=bHowManyShowAtOnce+1 to bHowManyTimesThroughLoop do begin
    ShapeDrawErase(0,4,iX[bNextIndexToDraw],iY[bNextIndexToDraw],
                                      clN[bNextIndexToDraw]);//Do new
    ShapeDrawErase(0,4,iX[bToErase],iY[bToErase],
                                      clN[bToErase]);//Lose old (Magic of XOR)
    //Yes, there is probably a more clever ways to do the next four
    //  lines... but remember: The each roll over at different points
    //  in the cycle...
    PickNewNumbers(bToErase);//Pick new for next time this index used.
    inc(bNextIndexToDraw);
      if bNextIndexToDraw>kLastIndex then bNextIndexToDraw:=0;
    inc(bToErase);
      if bToErase>kLastIndex then bToErase:=0;
    application.processmessages;//(Or else you don't see the draws
      //until loop finishes!)
    Sleep(bSleepBetween);
    end;//for

  //And clear the last ones... first adjust bToErase...

  for bCount:=0 to bHowManyShowAtOnce do begin
    ShapeDrawErase(0,4,iX[bToErase],
       iY[bToErase],clN[bToErase]);//Lose old (Magic of XOR)
    inc(bToErase);
      if bToErase>kLastIndex then bToErase:=0;
    application.processmessages;//(Or else you don't see the draws
      //until loop finishes!)
    Sleep(bSleepBetween);
    end;//for
end;// RandomlyPlacedShapes2

procedure TLDN180f1.RandomlyPlacedShapes;
const bLastIndex = 10;
var iX,iY:array[0..bLastIndex] of integer;
    bCount:byte;
begin
  randomize;
  for bCount:=0 to bLastIndex do begin
   iX[bCount]:=Random(iImageWidth);
   iY[bCount]:=Random(iImageHeight);
   end;//for

  Image1.Picture.Bitmap.canvas.pen.mode:=pmXor;
  for bCount:=0 to bLastIndex do
      ShapeDrawErase(1,4,iX[bCount],iY[bCount],RGBToColor(15,255,0)XOR clBkg);

end;// RandomlyPlacedShapes


procedure TLDN180f1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var dfIniFile:TIniFile;//See sheepdogguides.com/Lut/Lut2c.htm if you
  //want help with ini file stuff.
begin
  dfIniFile:=TIniFile.create('LDN180ini.txt');
  with dfIniFile do begin
     (*Not necessary, as the following are essentially constants, in the app
         WriteInteger('DrawingArea','Width',iImageWidth);
         WriteInteger('DrawingArea','Height',iImageHeight);
         ... but inplement these if there is a way for user
         to change the size of the drawing area while prgm
         is running
         *)
      WriteInteger('WindowPosnAndSize','Width',LDN180f1.width);
      WriteInteger('WindowPosnAndSize','Height',LDN180f1.height);
      WriteInteger('WindowPosnAndSize','Left',LDN180f1.left);
      WriteInteger('WindowPosnAndSize','Top',LDN180f1.top);

      WriteInteger('Colors','BackGroundOfGraph',clBkg);
      //If ever interactive color choosing becomes possible,
      //the complement of...
      //clBkg:=ReadInteger('Colors','BackGroundOfGraph',clTmp);
      //.. will have to be implemented.
      //For clBkg, clPnt0-2, for clLine0-2
  end;//with
end;//FormClose

procedure TLDN180f1.ShapeDrawErase(bWhich,bSize:byte;
     iX,iY:integer;clColorL:TColor);
//Params: valid values/ purpose
//   0 or 1/ bEraseDraw: Erase shape (0) or Draw it (1)
//   0...: Which shape. Only 0 valid at present, so not checked.
//   0..255: Size. Meaning varies with shape
//   iX,iY: Coord of CENTER of shape, in TImage units. (0,0 is upper left)
//
//By the magix of XOR, draw something once, and it appears. Draw over
//   it, i.e. call ShapeDrawErase one the same spot a second time, and you
//   will erase what you previously drew.
begin
  with Image1.Picture.Bitmap.canvas do begin
    pen.mode:=pmXor;
    pen.color:=clColorL;
    case bWhich of
    0:begin
      //Draw Square. bSize is HALF length of a side.
      //Good news! Lazarus doesn't mind if you try to draw
      //    past the edge of "the page".
      DrawLineForShape(iX-bSize,iY-bSize,iX+bSize,iY-bSize);
      lineto(iX+bSize,iY+bSize);
      lineto(iX-bSize,iY+bSize);
      lineto(iX-bSize,iY-bSize);
      end;//case 0 (must have ;'s except after one before "else")
    1:begin
      //Draw triangle
      DrawLineForShape(iX-bSize*2,iY-bSize*2,iX+bSize*2,iY-bSize*2);
      lineto(iX,iY+bSize*2);
      lineto(iX-bSize*2,iY-bSize*2);
      end//case 1... must NOT have ; before else
    else showmessage('Error in code: 17a302');
    end;//case
  end;//with
end;//ShapeDraw

procedure TLDN180f1.DrawTrialLine(bType:byte;clColorL:TColor);
//For some early testing of XOR
begin
with Image1.Picture.Bitmap.canvas do begin
  pen.mode:=pmXor;
  pen.color:=clColorL XOR clBkg;

 if bType=0 then begin
   moveto(0,0);
   lineto(iImageWidth,iImageHeight);
   moveto(36,0);
   lineto(iImageWidth,iImageHeight-32);
  end;//if bType:=0

 if bType=1 then begin
   moveto(0,0);
   lineto(iImageWidth,iImageHeight);
   moveto(18,0);
   lineto(iImageWidth,iImageHeight-16);
   end;//if bType:=1
 end;//with..
end;//DrawTrialLine

procedure TLDN180f1.DrawBarsOfColor;
//For some early testing of XOR
begin
  with Image1.Picture.Bitmap.canvas do begin
    brush.color:=clRed;
    FillRect(Rect(0,20,iImageWidth,50));
    brush.color:=clGreen;
    FillRect(Rect(0,70,iImageWidth,100));
    brush.color:=clBlue;
    FillRect(Rect(0,120,iImageWidth,150));
    brush.color:=clRed;
    FillRect(Rect(0,170,iImageWidth,250));
  end;//with
end;//DrawBarsOfColor;

procedure TLDN180f1.DrawLineForShape(iX0L,iy0L,iX1L,iY1L:integer);
begin
  with Image1.Picture.Bitmap.canvas do begin
    moveto(iX0L,iy0L);
    lineto(iX1L,iY1L);
    end;//with
end;//DrawLineForShape

procedure TLDN180f1.TestColors;
begin
   Image1.Picture.Bitmap.canvas.pen.mode:=pmXOR;

   Image1.Picture.Bitmap.canvas.pen.color:=clPnt0;
     DrawLineForShape(0,0,200,10);
   Image1.Picture.Bitmap.canvas.pen.color:=clPnt1;
     DrawLineForShape(0,0,190,30);
   Image1.Picture.Bitmap.canvas.pen.color:=clPnt2;
     DrawLineForShape(0,0,180,50);
   Image1.Picture.Bitmap.canvas.pen.color:=clLine0;
     DrawLineForShape(0,0,160,70);
   Image1.Picture.Bitmap.canvas.pen.color:=clLine1;
     DrawLineForShape(0,0,140,90);
   Image1.Picture.Bitmap.canvas.pen.color:=clLine2;
     DrawLineForShape(0,0,120,110);
end;//TestColors

end.

